// File    : DEMO.CPP
// Author  : Eric Woodruff,  CIS ID: 72134,1150
// Updated : Fri 08/26/94 19:17:59
// Compiler: Borland C++ 3.1
//
// Demo to test using BC++ 3.1 with TV 2.0.
//

#include <stdlib.h>

#define Uses_TApplication
#define Uses_TButton
#define Uses_TDialog
#define Uses_TInputLine
#define Uses_TKeys
#define Uses_TLabel
#define Uses_TMenuBar
#define Uses_TMenuItem
#define Uses_TRect
#define Uses_TStatusDef
#define Uses_TStatusItem
#define Uses_TStatusLine
#define Uses_TSubMenu
#define Uses_TRangeValidator
#include <tv.h>

const int cmDemo = 100;

class TMyApp : public TApplication
{
public:
    TMyApp();
    static TStatusLine *initStatusLine( TRect r );
    static TMenuBar *initMenuBar( TRect r );

    virtual void handleEvent(TEvent &event);
};

TMyApp::TMyApp() :
 TProgInit(&TMyApp::initStatusLine, &TMyApp::initMenuBar, &TMyApp::initDeskTop)
{
}

TStatusLine *TMyApp::initStatusLine(TRect r)
{
    r.a.y = r.b.y - 1;
    return new TStatusLine(r,
        *new TStatusDef( 0, 0xFFFF ) +
            *new TStatusItem(0, kbF10, cmMenu) +
            *new TStatusItem("~Alt-X~ Exit", kbAltX, cmQuit) +
            *new TStatusItem("~F3~ Demo", kbF3, cmDemo) );
}

TMenuBar *TMyApp::initMenuBar( TRect r )
{
    r.b.y = r.a.y + 1;
    return new TMenuBar(r,
        *new TSubMenu( "~F~ile", kbAltF )+
            *new TMenuItem("~D~emo", cmDemo, kbF3, hcNoContext, "F3") +
            *new TMenuItem("E~x~it", cmQuit, cmQuit, hcNoContext, "Alt-X") );
}

void TMyApp::handleEvent(TEvent &event)
{
    static char DemoField[11] = "0";

    TApplication::handleEvent(event);

    if(event.what == evCommand && event.message.command == cmDemo)
    {
        TDialog* dlg = new TDialog(TRect(0, 0, 35, 7),
            "TV 2.0/BC++ 3.1 Demo");

        if(dlg)
        {
            dlg->options |= ofCentered;

            TInputLine *ln = new TInputLine(TRect(20, 2, 32, 3), 11,
                new TRangeValidator(-50, 50));
            dlg->insert(ln);
            dlg->insert(new TLabel(TRect(2, 2, 19, 3), "Range -50 to 50:",
                ln));

            dlg->insert(new TButton(TRect(12, 4, 22, 6), "O~K~", cmOK,
                bfNormal));
            dlg->selectNext(False);

            // Use the new TProgram::executeDialog() function.
            executeDialog(dlg, &DemoField);
        }
    }
}

void main(void)
{
    TMyApp myApp;
    myApp.run();
    myApp.shutDown();
    exit(0);
}
